part of masamune;

class InlineAppPreview extends StatelessWidget {
  const InlineAppPreview({
    this.initialRoute,
    this.controller,
    this.routes,
    this.widgetTheme,
    this.theme,
    this.modules = const [],
    this.prefix,
    this.suffix,
  });
  final String? initialRoute;
  final ThemeData? theme;
  final NavigatorController? controller;
  final Map<String, RouteConfig>? routes;
  final WidgetTheme? widgetTheme;
  final List<Module> modules;
  final String? prefix;
  final String? suffix;

  @override
  Widget build(BuildContext context) {
    final moduleConfig = PageModule.merge(modules);
    final appModule = modules.whereType<AppModule>().firstOrNull;
    return AppScope(
      app: appModule ?? context.app,
      child: AdapterScope(
        modelAdapter:
            modules.whereType<ModelAdapter>().firstOrNull ?? context.model,
        platformAdapter: modules.whereType<PlatformAdapter>().firstOrNull ??
            context.platform,
        child: RoleScope(
          roles: appModule?.roles ?? context.roles,
          child: WidgetThemeScope(
            widgetTheme: widgetTheme ?? context.widgetTheme,
            child: Theme(
              data: appModule?.themeColor?.toThemeData() ??
                  theme ??
                  context.theme,
              child: InlinePageBuilder(
                prefix: prefix ?? "",
                suffix: suffix ?? "",
                initialRoute: initialRoute,
                controller: controller,
                routes: moduleConfig?.routeSettings?.merge(routes) ?? routes,
              ),
            ),
          ),
        ),
      ),
    );
  }
}
